! CALL GLPVCELl($S,$T,$Vxa,$Voca,$Ipv)      
      SUBROUTINE GLPVCELL(Sin,Tin,Vxa,Voca,Ipv)

!------------------------------------------------------------
!   Include and Common Block Declarations
!------------------------------------------------------------
      INCLUDE 'nd.h'
      INCLUDE 's0.h'
      INCLUDE 's1.h'
      INCLUDE 's2.h'
      INCLUDE 's4.h'
      INCLUDE 's8.h'
      INCLUDE 'branches.h' 

!------------------------------------------------------------
!  Argument List:
!------------------------------------------------------------

      REAL Sin
	REAL Tin        
      REAL Vxa
      REAL Voca
      REAL Ipv
      
!------------------------------------------------------------
!   Variable Declarations
!------------------------------------------------------------

      REAL q
      REAL K
      
      REAL Tref
	REAL Tzero
	REAL Sref

	REAL Aef
      REAL Di
      REAL Ebg
      REAL Iosr
      REAL Rfg
      REAL Ctg
     
      INTEGER Ncs
      INTEGER Ncp
      INTEGER Nms
	INTEGER Nmp
     
      
     
!------------------------------------------------------------
!   Temporary Variable Declarations
!------------------------------------------------------------
      
      REAL Tcelk      
      REAL Trefk

      REAL Vxc
      REAL Ios
      
      REAL Iphc
      REAL Idic
      REAL Ipha
      REAL Idia

      REAL Voc

      REAL tmp1
      REAL tmp2
	REAL tmp3
	REAL tmp4
	REAL tmp5
	REAL tmp6

 
!------------------------------------------------------------
!   Constant Definitions
!------------------------------------------------------------
      
      q = 1.6
      K = 1.38e-4
      
      Tref = 25.0
	Tzero = 273.15
      Sref = 1000.0

      Aef = 0.036
      Rs = 0.028
      Di = 1.5
      Ebg = 1.106
      Iosr = 1.35e-9
      Rfg = 0.05
	Ctg = 0.0017

!Arrey series and parolell numeber      
      Ncs = 36
      Ncp = 10
	Nms = 10
	Nmp = 10
	
!------------------------------------------------------------
! Do the math
!------------------------------------------------------------



! Ipv: PV arrey output current kA
      Tcelk 	= Tin + Tzero      
      Trefk 	= Tref +Tzero 
      
      tmp1    = q * Ebg / Di / k
	tmp2    = 1 / Trefk - 1 / Tcelk  
	Ios 	= (Tcelk / Trefk) ** 3 * Iosr * EXP( tmp1 * tmp2 )
	 
      Iphc 	= Sin * Rfg * Aef + Ctg * ( Tcelk - Trefk ) * Sin / Sref

      Vxc     = Vxa * 1000 / Nms / Ncs
      tmp3    = q * Vxc / Tcelk / Di / k    
	Idic	= Ios * ( EXP(tmp3) - 1 )

      Ipha	= Iphc * Ncp * Nmp
      Idia    = Idic * Ncp * Nmp

      Ipv 	= (Ipha - Idia) / 1000

! Voca: PV arrey output voltage kV
           
      Voc   	= Di * k * Tcelk / q
      
      tmp4	= LOG(Iphc / Ios)
	Voca    = tmp4 * Voc * Ncs * Nms / 1000
          


      RETURN
      END